
#include <avr/io.h>
#define F_CPU			8000000				//TAKT
#include <util/delay.h>
#include "lcd-routine.h"

void LCD_reset(void)
{
	for(unsigned char i=0;i<=2;i++)
	{
		LCD_PORT=0x30;						//RESET TEIL I
		LCD_enable();						//fallende Flanke an E
		_delay_ms(5);
	}
	_delay_us(100);
	LCD_PORT=0x30;
	LCD_enable();
	_delay_ms(5);
}
void LCD_init(void)
{
	LCD_DDR=0xff;							//Ausgnge fr PORT_LCD
	LCD_E_RS_DDR|=(1<<LCD_RS);				//RS Ausgang
	LCD_E_RS_DDR|=(1<<LCD_E);				//E Ausgang
	LCD_E_RS_PORT&=~(1<<LCD_RS);			//RS=LOW
	_delay_us(100);
	LCD_reset();

	LCD_PORT=0x20;							//4-bit Modus aktivieren
	LCD_enable();
	_delay_ms(5);
	LCD_cmd(0x28);							//Function Set 4 Bit, 2 Zeilen, 5x7
	LCD_off();
	LCD_clear();
	LCD_cmd(0x06);
	LCD_on();
	
}
void LCD_string(char *string)
{
	while(*string)
	{
		LCD_data(*string);
		string++;
	}
}	
void LCD_RS_HIGH(void)
{
	LCD_E_RS_PORT|=(1<<LCD_RS);
}
void LCD_data(unsigned char x)
{
	LCD_RS_HIGH();
	LCD_out(x);
}
void LCD_cmd(unsigned char x)
{
	LCD_E_RS_PORT&=~(1<<LCD_RS);				//RS=0
	LCD_out(x);
}
void LCD_enable(void)
{
	LCD_E_RS_PORT|=(1<<LCD_E);					//E=1
	_delay_us(3);
	LCD_E_RS_PORT&=~(1<<LCD_E);					//E=0
}
void LCD_out(unsigned char x)
{
	unsigned char tmp=x;
	tmp=(tmp<<4)|(tmp>>4);					//swap
	x&=0xf0;								//x AND 0b11110000
	tmp&=0xf0;								//tmp AND 0b11110000
	LCD_PORT=x;								//x auf LCD ausgeben
	LCD_enable();
	LCD_PORT=tmp;							//tmp auf LCD ausgeben
	LCD_enable();
	_delay_ms(5);
}
void LCD_clear(void)
{
	LCD_out(0x01);							//DISPLAY lschen
	LCD_RS_HIGH();
	_delay_ms(5);
}
void LCD_off(void)
{
	LCD_out(0x08);							//DISPLAY off
	LCD_RS_HIGH();
	_delay_ms(5);
}
void LCD_on(void)
{
	LCD_out(0x0e);							//DISPLAY on
	LCD_RS_HIGH();
	_delay_ms(5);
}
void LCD_home(void)
{
	LCD_out(0x02);							//CURSOR home
	LCD_RS_HIGH();
	_delay_ms(5);
}
void LCD_1Line(void)
{
	LCD_out(0x80);							//DISPLAY erste Zeile
	LCD_RS_HIGH();
	_delay_ms(5);
}
void LCD_2Line(void)
{
	LCD_out(0x60);							//DISPLAY zweite Zeile
	LCD_RS_HIGH();
	_delay_ms(5);
}
void LCD_goto(unsigned char x)
{
	x|=0x80;								//x AND 0b10000000
	LCD_out(x);
	_delay_ms(5);
}	











	
